// License: AGPLv3 or later. https://www.gnu.org/licenses/licenses.html

#include <iostream>
#include <vector>
#include "abc.h"

using namespace std;

int main(int argc, char *argv[])
{
    input_files_name args = perform_checks_on_args(argc, argv);
    
    input_files_textlines input_files_by_line = read_input_files(
        args);
    
    vector<student> students = generate_students_struct(
        input_files_by_line.students);
    
    vector<subject> subjects = generate_subjects_struct(
        input_files_by_line.subjects);
    
    vector<teacher> teachers = generate_teachers_struct(
        input_files_by_line.teachers);
    
    add_teachers_vector_index_number_to_subjects_struct(teachers, subjects);
    
    process_students_and_generate_results(
        students, subjects, teachers);
    
    write_results_to_output_file(students, args.results);
    
    return 0;
}
